#!/usr/bin/wish -f
# Front-end for makespec, program created by Jiri Kouba
#This creates RPMs form tar.gz
#************************************************************************
# procedures:
#------------------------------------------------------------------------
proc fileDialog {  ent searchdir operation} {
global fileName 
#tim se vyresil prenos teto promenne vne
    #   Type names		Extension(s)	Mac File Type(s)
    #
    #---------------------------------------------------------
    set types {
	{"Text files"		{*.txt}		TEXT}
	{"TAR gzip files"		{.tgz .tar.gz}	}
	{"RPM binary files"		{.rpm .RPM}	}
	{"SPEC files"		{.spec* .SPEC*}	}
	{"All files"		*}
    }
    if {$operation == "open"} {
	set fileName [tk_getOpenFile -filetypes $types -initialdir $searchdir ] 
#vimni si, e tk funkce se vol v []
    } else {
	set fileName [tk_getSaveFile -filetypes $types  \
	    -initialfile Untitled -defaultextension .txt]
    }
    if [string compare $fileName ""] {
#jde to vdycky touto cestou  przdnho etzce
	$ent delete 0 end  
#vymaz entry
	$ent insert 0 $fileName 
#vloz do nej promennou jmena souboru
	$ent xview end 


    } 
}

#************************************************************************
proc newrpm {  } {
global w u u1 g searchdir

set w .newwin
#set searchdir /usr/src/redhat/BUILD

catch {destroy $w}
toplevel $w
wm title $w "Nov balk"
wm iconname $w ""

label $w.msg -wraplength 4i -justify left -text "RPM"
pack $w.msg -side top

wm title $w "Nov balk - vstupn daje"
wm iconname $w "Nov balk"

label $w.msg1 -wraplength 4i -justify left -text "Vyplte nsledujc daje"
pack $w.msg1 -side top

frame $w.buttons1
pack $w.buttons1 -side bottom -fill x -pady 2m
button $w.buttons1.dismiss -text Zruit -command "destroy $w"
button $w.buttons1.run -text Dle -command "runrpm $searchdir"
pack $w.buttons1.run $w.buttons1.dismiss  -side left -expand 1




foreach i { f2 f3 f4 f5 f6 f7 f8 f9 f10 f11} {
    frame $w.$i -bd 2
    entry $w.$i.entry -relief sunken -width 40 -textvariable m$i
    label $w.$i.label
    pack $w.$i.entry -side right
    pack $w.$i.label -side left
}

$w.f2.label config -text "Titulek programu:"
$w.f3.label config -text "Jmno programu:"
$w.f4.label config -text "Jmno specilnho souboru:"
$w.f5.label config -text "slo verze"
$w.f6.label config -text "Release"
$w.f7.label config -text "email balie"
$w.f8.label config -text "Podrobn popis balku"
$w.f9.label config -text "Vlastnk"
$w.f10.label config -text "Skupina"
$w.f11.label config -text "Prva seln"

pack $w.msg $w.f2 $w.f3 $w.f4 $w.f5 $w.f6 $w.f7 $w.f8 $w.f9 $w.f10 $w.f11 -side top -fill x
bind $w <Return> "destroy $w"



frame $w.$u
entry $w.$u.entry -relief sunken -width 40 -textvariable srcfile
$w.$u.entry insert 0 ""
label $w.$u.label
    pack $w.$u.entry -side right
    pack $w.$u.label -side left
$w.$u.label config -text "Zadej zdrojov soubor:      "
button $w.$u.but -text "Soubor vyber..." -command "fileDialog  $w.$u.entry  $searchdir open"


frame $w.$u1
entry $w.$u1.entry1 -relief sunken -width 40 -textvariable ctntfile
$w.$u1.entry1 insert 0 ""
label $w.$u1.label1
    pack $w.$u1.entry1 -side right
    pack $w.$u1.label1 -side left
$w.$u1.label1 config -text "Zadej  soubor obsahu balku:      "
button $w.$u1.but1 -text "Soubor vyber..." -command "fileDialog  $w.$u1.entry1 $searchdir open"
pack $w.$u $w.$u1 -side bottom -fill x 
pack $w.$u.but  $w.$u1.but1 -side left -fill x   




frame $w.$g
scrollbar $w.$g.yscrollbar -command "$w.$g.list yview" -relief raised -orient vertical
scrollbar $w.$g.xscrollbar -command "$w.$g.list xview" -relief raised -orient horizontal
pack $w.$g
pack $w.$g.xscrollbar -side bottom -fill x
pack $w.$g.yscrollbar -side right -fill y
listbox $w.$g.list -font fixed -relief raised -selectmode browse \
    -yscroll "$w.$g.yscrollbar set" -xscroll "$w.$g.xscrollbar set" -width 80
pack $w.$g.list -fill both -expand 1


$w.$g.list insert 0 "Amusements/Games" \
"Amusements/Graphics" \
"Applications/Archiving" \
"Applications/Communications" \
"Applications/Databases" \
"Applications/Editors" \
"Applications/Emulators" \
"Applications/Engineering" \
"Applications/File" \
"Applications/Internet" \
"Applications/Multimedia" \
"Applications/Productivity" \
"Applications/Publishing" \
"Applications/System" \
"Applications/Text" \
"Development/Debuggers" \
"Development/Languages" \
"Development/Libraries" \
"Development/System" \
"Development/Tools" \
"Documentation" \
"System Environment/Base" \
"System Environment/Daemons" \
"System Environment/Kernel" \
"System Environment/Libraries" \
"System Environment/Shells" \
"User Interface/Desktops" \
"User Interface/X" \
"User Interface/X Hardware Support"                                     
}
#------------------------------------------------------------------------
proc runrpm { searchdir } {
global w g u u1 v  mf2 mf3 mf4 mf5 mf6 thegroup mf7 mf8 mf9 mf10 mf11 srcfile ctntfile 

if { [ $w.$g.list curselection ] == "" } {

toplevel $v
wm title $v "Upozornn"
    frame $v.top -relief raised -border 1
    pack $v.top -side top -fill both
    frame $v.bot -relief raised -border 1
    pack $v.bot -side bottom -fill both
    message $v.top.msg -width 6i -anchor center \
	-text "Muste mt vybranou skupinu \
	\n
	\ns kam program pat. "
	
    pack $v.top.msg -side top -expand 1 -fill both -padx 5m -pady 5m
    button $v.okbutton -text "OK" -command {destroy $v}
    pack $v.okbutton -side bottom
    grab $v
    focus $v

} else { 
set thegroup [ $w.$g.list get [ $w.$g.list curselection ]]
}
exec xterm -fn 10x20 -e echo  $searchdir $mf2 $mf3 $mf4 $mf5 $mf6 \
$thegroup $mf7  $srcfile $ctntfile $mf8  $mf11 $mf9 $mf10 >/tmp/makespec.txt

exec xterm -fn 10x20 -e  makespec.sh  $searchdir $mf2 $mf3 $mf4 $mf5 $mf6 \
$thegroup $mf7  $srcfile $ctntfile $mf8  $mf11 $mf9 $mf10 }
	
#------------------------------------------------------------------------
proc openrpm {} {
global w u u1 g rpms specfil searchdir
set w .rpmwin 

catch {destroy $w}
toplevel $w
wm title $w "Vytvoen balky"
wm iconname $w ""
frame $w.rpms
entry $w.rpms.entry1 -relief sunken -width 40 -textvariable specfil
$w.rpms.entry1 insert 0 ""
label $w.rpms.label1
    pack $w.rpms.entry1 -side right
    pack $w.rpms.label1 -side left
$w.rpms.label1 config -text "Vyber speciln  soubor:      "
button $w.rpms.but1 -text "Soubor vyber..." -command "fileDialog  $w.rpms.entry1 $searchdir open" 
button $w.rpms.but2 -text "Edituj" -command "rpmedit"
button $w.rpms.but3 -text "Vytvo RPM" -command "rpmuse"
button $w.rpms.but4 -text "Instaluj RPM" -command "rpmuse"
button $w.rpms.but5 -text "Zkuebn" -command "trialrpm"
pack $w.rpms -side bottom -fill x 
pack $w.rpms.but1 $w.rpms.but2 $w.rpms.but3 $w.rpms.but4 $w.rpms.but5 -side left -fill x   


}
#------------------------------------------------------------------------
proc rpmedit {} {
global w specfil
exec kedit $specfil
}
#------------------------------------------------------------------------
proc rpmuse {} {
global w specfil
exec xterm -fn 10x20 -e rpm -ba $specfil
}
#------------------------------------------------------------------------
proc rpminst {} {
global w specfil
exec xterm -fn 10x20 -e rpm -i $specfil
}
#------------------------------------------------------------------------
proc trialrpm {} {
global v w specfil
exec tar zxvf  $specfil
exec xterm -fn 10x20 
exec touch /tmp/timestamp
toplevel $v
wm title $v "Upozornn"
    frame $v.top -relief raised -border 1
    pack $v.top -side top -fill both
    frame $v.bot -relief raised -border 1
    pack $v.bot -side bottom -fill both
    message $v.top.msg -width 6i -anchor center \
	-text "Te tvom soubor obsahu balku \
	\n za koen beru /usr .
	\n Me to trvat pr minut. 
	\n Pak si soubor obsahu balku najdi a doedituj
	\n a me zat tvoit spec soubor."
	
    pack $v.top.msg -side top -expand 1 -fill both -padx 5m -pady 5m
    button $v.okbutton -text "OK" -command {findchanged}
    pack $v.okbutton -side bottom
    grab $v
    focus $v

}
#------------------------------------------------------------------------
proc findchanged {} {
global v specfil
destroy $v
exec find /usr -newer /tmp/timestamp -type f -print >$specfil-changed.txt
}
#------------------------------------------------------------------------

proc howto {} {
    global appname
    toplevel .uwin -class Dialog
    wm title .uwin "Howto "
    frame .uwin.top -relief raised -border 1
    pack .uwin.top -side top -fill both
    frame .uwin.bot -relief raised -border 1
    pack .uwin.bot -side bottom -fill both
    message .uwin.top.msg -width 6i -anchor center \
	-text "Jak vyrobit RPM balk ?\
	\n
	\nProstudujte si INSTALL a pokud jde o obvykl
	\n postup .-configure, make a make install,
	\n provete tyto pkazy a sestavte 
	\n soubor obsahu balku pomoc
	\n find / -mtime -1 -type f >/tmp/bbb.txt.
	\n 
	\n Nebo prove kompilaci Otevi_Zkuebn
	\n 
	\n Pak dej Nov balk, vypl vechna vstupn pole a stiskni Dle.
	\n"
	
    pack .uwin.top.msg -side top -expand 1 -fill both -padx 5m -pady 5m
    button .uwin.okbutton -text "OK" -command {destroy .uwin}
    pack .uwin.okbutton -side bottom
    grab .uwin
    focus .uwin
}
#------------------------------------------------------------------------
proc howuninstall {} {
    global appname
    toplevel .uwin -class Dialog
    wm title .uwin "Jak odinstalovat $appname"
    frame .uwin.top -relief raised -border 1
    pack .uwin.top -side top -fill both
    frame .uwin.bot -relief raised -border 1
    pack .uwin.bot -side bottom -fill both
    message .uwin.top.msg -width 6i -anchor center \
	-text "Jak odinstalovat $appname?\
	\n
	\nJednodue smate tento  soubor. "
	
    pack .uwin.top.msg -side top -expand 1 -fill both -padx 5m -pady 5m
    button .uwin.okbutton -text "OK" -command {destroy .uwin}
    pack .uwin.okbutton -side bottom
    grab .uwin
    focus .uwin
}
#------------------------------------------------------------------------
proc about {} {
    global appname
    toplevel .awin -class Dialog
    wm title .awin "About $appname"
    frame .awin.top -relief raised -border 1
    pack .awin.top -side top -fill both
    frame .awin.bot -relief raised -border 1
    pack .awin.bot -side bottom -fill both
    message .awin.top.msg -width 5i -anchor center \
	-text "$appname\
	\n
	\n
MAKESPECgui is an window interface for RPM specfile management.\
This file is freeware and it was last modified in November, 7th 2000.\
No warranty granted.\	
	\nContact me: jiri.kouba@volny.cz\
	\nMy homepage: www.volny.cz/jiri.kouba\
	\n
	\nCopyright (C) 2000 Jiri Kouba. All Rights Reserved."
    pack .awin.top.msg -side top -expand 1 -fill both -padx 5m -pady 5m
    button .awin.okbutton -text "OK" -command {destroy .awin}
    pack .awin.okbutton -side bottom
    grab .awin
    focus .awin
}
#------------------------------------------------------------------------
proc quitme {} {
 
    destroy .
}
#************************************************************************

set appname "MAKESPECgui Tcl 1.0"
set b .base
set v .alertwin
set u files
set u1 files1
set g groups
set rpm /usr/src/redhat/RPMS
set searchdir /usr/src/redhat
catch {destroy $w}
toplevel $b
wm title $b "Balme RPM"
wm iconname $b "Tvorba RPM"

label $b.msg -wraplength 4i -justify left -text "Udaje pro RPM"
pack $b.msg -side top
 

#Jeste parametry
#exec xterm -fn 10x20 -e /usr/local/bin/prespec.sh
########
wm title . $appname

frame .mbar -relief raised -bd 2
menubutton .mbar.file -text "Soubor" -underline 0 \
    -menu .mbar.file.menu


menubutton .mbar.help -text "Help" -underline 0 -menu .mbar.help.menu

menu .mbar.file.menu

.mbar.file.menu add command -label "Otevi" -underline 0 \
    -command {openrpm}
.mbar.file.menu add command -label "Zkuebn" -underline 0 \
    -command {openrpm}
.mbar.file.menu add command -label "Quit" -underline 0 \
    -command {quitme}
#    -accelerator "Alt+F4"


menu .mbar.help.menu
.mbar.help.menu add command -label "O aplikaci..." -underline 0 \
    -command {about}
.mbar.help.menu add command -label "Jak odinstalovat..." -underline 0 \
    -command {howuninstall}
.mbar.help.menu add command -label "HOWTO..." -underline 0 \
   -command {howto}

pack .mbar -side top -fill x
pack .mbar.file   -side left -in .mbar
pack .mbar.help -side right -in .mbar

frame .buttons
pack .buttons -side bottom -fill x -pady 2m
button .buttons.nek -text "Nov balk" -command "newrpm"
button .buttons.chek -text "Vybran balk" -command "openrpm"
pack  .buttons.nek  -side left -expand 1
pack  .buttons.chek  -side left -expand 1



#poznatky: patnou cestu to pe, kdy prvek nem svj rm, nebo u existuje, co
#vznik vtinou tak, e lovk zapomene v cest na njakou promnnou a tm s eprvek polo
#na ji existujc
#toplevel udl nov koenov okno 
#kdy v procedue globln promnn, tak se do porcedury nepedv parametrem



