#!/bin/bash 
#tvorba souboru zmen
if [ "$*" = "" ] ; then
echo "Syntaxe prespec.sh  zdrojovy_soubor s uplnou cestou"
exit
else
BASEDIR=/usr/src/redhat
SOURCEDIR=SOURCES
SOURCEFILEDIR=$1
  if [ ! -f $SOURCEFILEDIR ] ; then
  echo 'Zadany soubor neexistuje'
  exit
  fi

FILEDIR=`dirname $SOURCEFILEDIR`
FILE=`basename $SOURCEFILEDIR`
  if [ "$FILEDIR" = "$BASEDIR"/"$SOURCEDIR" ] ; then
  :
  else
   echo "Kopiruji $SOURCEFILEDIR na spravne misto"
   cp $SOURCEFILEDIR "$BASEDIR"/"$SOURCEDIR"
  fi

EDIT=kedit
VERBOSE=""
#VERBOSE="v"

pushd "$BASEDIR"/"$SOURCEDIR"
pwd

KIND=`file $FILE | cut -d":" -f2 | cut -c1-21`



echo $KIND

	if [  "$KIND" = " gzip compressed data" ] ; then
        PROG_EXTRACT=z
          else 
		if [ "$KIND" = " bzip2 compressed data"   ] ; then 
                  PROG_EXTRACT=I
                 
                  else
			echo Soubor je zabalen v jinem nez gzip programu
		fi
	fi

#typ rozbaleni

#
tar "$PROG_EXTRACT"x"$VERBOSE"f $FILE


EXTDIRPOM=`tar "$PROG_EXTRACT"tf $FILE |tail -1` 
EXTDIR=`echo $EXTDIRPOM |cut -d"/" -f1`
#head totiz prida 1. soubor adresare

rm -f $STAMP1
echo 'Je treba zjistit, jestli uz neni *spec file v baliku'
pushd $EXTDIR
SPEC_FILE=`find ./ -name "*.spec" -print`
if [  $SPEC_FILE ] ; then 
  echo "Specialni soubor $SPEC_FILE je v baliku a nemusi byt tvoren"
  exit
fi

CONFIGURE_FILE=`find ./ -name configure -print`
if [ ! $CONFIGURE_FILE ] ; then
  echo "Soubor configure neexistuje, kompilace atypicka, proved ji rucne, ja koncim"
exit
fi
CONFIGURE_DIR=`dirname $CONFIGURE_FILE`
pushd $CONFIGURE_DIR
exit
echo Zahajuji I. kompilaci
pwd
./configure
touch ../timestamp
#nemenit poradi
make

make install
find / -newer ../timestamp -type f -print |grep -v proc >"$BASEDIR"/"$FILE".txt
$EDIT  "$BASEDIR"/"$FILE".txt 
echo "Tvorit RPM A/N a Enter"
 read Q
  if [ "$Q" = "A" ] || [ "$Q" = "a" ] ; then
  makespec.tcl
  fi 

fi
exit



	

